/*
 * Copyright (c) 2005 by G4SRA
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/* 
 * Authors: G4SRA (cradford@bcs.org.uk)
 */

#ifndef _OM_BEQUEST_H
#define _OM_BEQUEST_H

/* 
 * R?..... - Request (message signifys information wanted)
 * B?..... - Bequest (message signifys information given)
 * ?NN?... - Reference by Node Number (local lookup to determine remote address)
 * ?IP?... - Reference by IP Address
 * ?NA?... - Reference by Net Address
 */

/* Bequest Messages (the trailing space is required)  */

#define MSG_BEQ_IP_OMV "BIPOMV "
#define MSG_BEQ_NA_OMV "BNAOMV "
#define MSG_BEQ_NN_OMV "BNNOMV "

#define MSG_BEQ_IP_NODE_IP "FUBAR "
#define MSG_BEQ_NA_NODE_IP "FUBAR "
#define MSG_BEQ_NN_NODE_IP "BNNNIP "

#define MSG_BEQ_IP_ARCH "BIPA "
#define MSG_BEQ_NA_ARCH "BNAA "
#define MSG_BEQ_NN_ARCH "BNNA "

#define MSG_BEQ_IP_NCPU "BIPNCPU "
#define MSG_BEQ_NA_NCPU "BNANCPU "
#define MSG_BEQ_NN_NCPU "BNNNCPU "

#define MSG_BEQ_IP_CPUGRUNT "BIPG "
#define MSG_BEQ_NA_CPUGRUNT "BNAG "
#define MSG_BEQ_NN_CPUGRUNT "BNNG "

#define MSG_BEQ_IP_MACADDR "BIPMA "
#define MSG_BEQ_NA_MACADDR "BNAMA "
#define MSG_BEQ_NN_MACADDR "BNNMA "

#define MSG_BEQ_IP_NETCOST "BIPC "
#define MSG_BEQ_NA_NETCOST "BNAC "
#define MSG_BEQ_NN_NETCOST "BNNC "

#define MSG_BEQ_IP_SPEED "BIPS "
#define MSG_BEQ_NA_SPEED "BNAS "
#define MSG_BEQ_NN_SPEED "BNNS "

#define MSG_BEQ_IP_LOAD "BIPL "
#define MSG_BEQ_NA_LOAD "BNAL "
#define MSG_BEQ_NN_LOAD "BNNL "

#define MSG_BEQ_IP_LIFE "BIPLF "
#define MSG_BEQ_NA_LIFE "BNALF "
#define MSG_BEQ_NN_LIFE "BNNLF "

#define MSG_BEQ_IP_FREE_MEM "BIPFM "
#define MSG_BEQ_NA_FREE_MEM "BNAFM "
#define MSG_BEQ_NN_FREE_MEM "BNNFM "

#define MSG_BEQ_IP_FLAGS "BIPF "
#define MSG_BEQ_NA_FLAGS "BNAF "
#define MSG_BEQ_NN_FLAGS "BNNF "

#define MSG_BEQ_IP_INS "BIPINS "
#define MSG_BEQ_NA_INS "BNAINS "
#define MSG_BEQ_NN_INS "BNNINS "

#define MSG_BEQ_IP_DEL "BIPDEL "
#define MSG_BEQ_NA_DEL "BNADEL "
#define MSG_BEQ_NN_DEL "BNNDEL "

#define MSG_BEQ_IP_EXIT "BIPEXIT "
#define MSG_BEQ_NA_EXIT "BNAEXIT "
#define MSG_BEQ_NN_EXIT "BNNEXIT "

#define MSG_BEQ_IP_JOIN "BIPJOIN "
#define MSG_BEQ_NA_JOIN "BNAJOIN "
#define MSG_BEQ_NN_JOIN "BNNJOIN "

#define MSG_BEQ_IP_POWERDOWN "BIPPD "
#define MSG_BEQ_NA_POWERDOWN "BNAPD "
#define MSG_BEQ_NN_POWERDOWN "BNNPD "


int handle_bequest (char *buf);
int handle_bequest_1 (char *buf);

#endif
