/*
    name : omlocal.h

    omlib : openMosix Userland Tools library

    Copyright (C) 2005 Pierre Pacaud, Thomas Roux, Matthieu Protin
        Ecole Polytechnique de l'Universit de Tours, Dpartement Informatique
    Copyrigth (C) 2005 Evan Hisey, Nathan Wiegand, G4SRA

    omlib is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING . If not, write to the
    Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _OM_OMLOCAL_H
#define _OM_OMLOCAL_H

#include <stdint.h>

/* This function is so easy it might as well not exist.
 * Just calls uname and returns machine.
 */
char *getLocalArch (void);

/* This function is so easy it might as well not exist.
 * Just calls getloadavg() which is in stdlib.h 
 */
double getLocalLoadAvg (void);

/* returns the number of kiloBytes of free memory
 * via /proc/meminfo.  I think that on some systems
 * sysctl could be used. 
 */
int getLocalFreeMem (void);

/* returns the number of logical cpus on the machine
 * via /proc/cpuinfo, and stores the MHz of each in
 * an array.  Call with,
 *   int *Mips = NULL;
 *   int ncpu = getLocalCPUMips(&Mips);
 * Again, I think that on some systems, sysctl will do 
 * a lot of this for us, especially HW_NCPU which returns
 * the number of logical processors (on Macs at least).
 */
int getLocalCPUMips (int **mips);

/* returns the number of logical cpus on the machine */
int getLocalNumCPUs (void);

/* returns the comparative CPU power of the machine */
int getLocalCPUGrunt (void);

int getLocalMACAddr (unsigned char *mac);

/* work in progress */
char *getLocalOMLibVer (void);
char *getLocalKernelVer (void);

/* openmosix_check verify that system is running
*  an openmosix enabled kernel.*/
int openmosix_check (void);

#endif
