/*
 * Copyright (c) 2002 by Louis Zechtzer
 * Copyright (c) 2005 by Nathan Wiegand 
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/* 
 * Authors: Louis Zechtzer (lou@clarity.net)
 * Authors: Nathan Wiegand (nathanwiegand@gmail.com)
 * Authors: G4SRA (cradford@bcs.org.uk) 
 */
/* Updated to OpenMosix 2.4.17 and afterwards by David Santo Orcero
 * irbis@orcero.org http://www.orcero.org/irbis */

#ifndef _OM_OPENMOSIX_H
#define _OM_OPENMOSIX_H

#include <sys/socket.h>
#include <netinet/in.h>
#include <stdint.h>
#include "vector.h"
#include "libmisc.h"
#include "misc.h"

#if 0
/* XXX - from linux/mosixnet.h (include the file here instead) */
typedef struct mosixnet {
  int base;
  struct sockaddr saddr;
  int cnt;
} mosixnet_t;
#endif

#ifdef TESTING
extern int test_openmosix ();
#endif

int omd_initialise (uint32_t addr);
/*int omd_initialise(const struct in_addr *node_addr, int sz); */

int omd_finalize (void);

int omd_ins_node (const struct in_addr *node_addr, const struct in_addr
		  *alias, int alias_cnt);

int omd_del_node (const struct in_addr *node_addr, const struct in_addr
		  *alias, int alias_cnt);

void omAgeNodeData (void);
void omd_print_cluster (int level);
int omd_cluster_size (void);
int omd_heir_arch (int nn);
int omd_heir_ver (int nn);


extern vector *cluster;
extern int omd_poll;
extern int omd_node_life;

typedef struct sss {
  int pid;
  char *tcomm;
  char state;
  int ppid;
  int pgid;
  int sid;
  int tty_nr;
  int tty_pgrp;
  unsigned long task_flags;
  unsigned long min_flt;
  unsigned long cmin_flt;
  unsigned long maj_flt;
  unsigned long cmaj_flt;
  unsigned long utime;
  unsigned long stime;
  long cutime;
  long cstime;
  long priority;
  long nice;
  int num_threads;
  long it_real_value;
  unsigned long start_time;
  unsigned long vsize;
  unsigned long mm_counter;	/* you might want to shift this left 3 */
  unsigned long rsslim;
  unsigned long mm_start_code;
  unsigned long mm_end_code;
  unsigned long mm_start_stack;
  unsigned long esp;
  unsigned long eip;
/* The signal information here is obsolete.
* It must be decimal for Linux 2.0 compatibility.
* Use /proc/#/status for real-time signals.
*/
  unsigned long task_pendingsig;
  unsigned long task_blockedsig;
  unsigned long sigignsig;
  unsigned long sigcatchsig;
  unsigned long wchan;
  unsigned long junk1;
  unsigned long junk2;
  int task_exit_signal;
  int task_cpu;
  unsigned long task_rt_priority;
  unsigned long task_policy;
} proc_t;

#endif /* __OPENMOSIX_H */
