/*
 * Copyright (c) 2005 by G4SRA
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/* 
 * Authors: G4SRA (cradford@bcs.org.uk)
 */

#ifndef _OM_REQUEST_H
#define _OM_REQUEST_H

/*
 * R?..... - Request (message signifys information wanted)
 * B?..... - Bequest (message signifys information given)
 * ?NN?... - Reference by Node Number (local lookup to determine remote address)
 * ?IP?... - Reference by IP Address
 * ?NA?... - Reference by Net Address
 */

/* Request Messages (the trailing space is important) */
#define MSG_REQ_IP_OMV "RIPOMV "
#define MSG_REQ_NA_OMV "RNAOMV "
#define MSG_REQ_NN_OMV "RNNOMV "

#define MSG_REQ_IP_CLUSTER_SIZE "RIPCS "
#define MSG_REQ_NA_CLUSTER_SIZE "RNACS "
#define MSG_REQ_NN_CLUSTER_SIZE "RNNCS "

#define MSG_REQ_IP_NODE_IP "FUBAR "
#define MSG_REQ_NA_NODE_IP "FUBAR "
#define MSG_REQ_NN_NODE_IP "RNNNIP "

#define MSG_REQ_IP_ARCH "RIPA "
#define MSG_REQ_NA_ARCH "RNAA "
#define MSG_REQ_NN_ARCH "RNNA "

#define MSG_REQ_IP_CPUGRUNT "RIPG "
#define MSG_REQ_NA_CPUGRUNT "RNAG "
#define MSG_REQ_NN_CPUGRUNT "RNNG "

#define MSG_REQ_IP_MACADDR "RIPMA "
#define MSG_REQ_NA_MACADDR "RNAMA "
#define MSG_REQ_NN_MACADDR "RNNMA "

#define MSG_REQ_IP_NETCOST "RIPC "
#define MSG_REQ_NA_NETCOST "RNAC "
#define MSG_REQ_NN_NETCOST "RNNC "

#define MSG_REQ_IP_LIFE "RIPLF "
#define MSG_REQ_NA_LIFE "RNALF "
#define MSG_REQ_NN_LIFE "RNNLF "

#define MSG_REQ_IP_LOAD "RIPL "
#define MSG_REQ_NA_LOAD "RNAL "
#define MSG_REQ_NN_LOAD "RNNL "

#define MSG_REQ_IP_FREE_MEM "RIPFM "
#define MSG_REQ_NA_FREE_MEM "RNAFM "
#define MSG_REQ_NN_FREE_MEM "RNNFM "

#define MSG_REQ_IP_FLAGS "RIPF "
#define MSG_REQ_NA_FLAGS "RNAF "
#define MSG_REQ_NN_FLAGS "RNNF "

#define MSG_REQ_IP_POWERDOWN "RIPPD "
#define MSG_REQ_NA_POWERDOWN "RNAPD "
#define MSG_REQ_NN_POWERDOWN "RNNPD "

/* depreciated */

#define MSG_REQ_IP_SPEED "RIPS "
#define MSG_REQ_NA_SPEED "RNAS "
#define MSG_REQ_NN_SPEED "RNNS "

#define MSG_REQ_IP_NCPU "RIPNCPU "
#define MSG_REQ_NA_NCPU "RNANCPU "
#define MSG_REQ_NN_NCPU "RNNNCPU "

typedef struct reqfun {
  char *msg;
  int len;
  int (*fun) (int);
  char *fmt;
  void *arg1;
} reqfun_t;

int handle_request (int sd, char *buf);

#include <netinet/in.h>
void omd_volatile (const struct in_addr *addr);
int omd_complete_node (const struct in_addr *node_addr);
#endif
