/*
 * Copyright (c) 2005 by G4SRA
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/* 
 * Authors: G4SRA (cradford@bcs.org.uk)
 */

#ifdef _SEMAPHORE_

#include <unistd.h>

#include "semaphore.h"
#include "omsyslog.h"

rw_semaphore_t cluster_semaphore;

void
init_rwsem (rw_semaphore_t * sem)
{
  sem->lock_rw = 0;
  sem->lock_r = 0;
}

void
down_write (rw_semaphore_t * sem)
{
  while (((sem->lock_r)--) != 0) {
    ++(sem->lock_r);
    omd_sleep (1);
    omLog (OM_LOG_ALERT, "Waiting on down_write sem->lock_r");
  }
  while (((sem->lock_rw)--) != 0) {
    ++(sem->lock_rw);
    omd_sleep (1);
    omLog (OM_LOG_ALERT, "Waiting on down_write sem->lock_rw");
  }
}

void
up_write (rw_semaphore_t * sem)
{
  if (sem->lock_r < 0)
    ++(sem->lock_r);
  else
    omLog (OM_LOG_ALERT, "Too many up_write sem->lock_r");
  if (sem->lock_rw < 0)
    ++(sem->lock_rw);
  else
    omLog (OM_LOG_ALERT, "Too many up_write sem->lock_rw");
}

void
down_read (rw_semaphore_t * sem)
{
  while (((sem->lock_r)--) != 0) {
    ++(sem->lock_r);
    omd_sleep (1);
    omLog (OM_LOG_ALERT, "Waiting on down_read");
  }
  (sem->lock_rw)--;
  ++(sem->lock_r);
}

void
up_read (rw_semaphore_t * sem)
{
  if (sem->lock_rw < 0)
    ++(sem->lock_rw);
  else
    omLog (OM_LOG_ALERT, "Too many up_read sem->lock_rw");
}

#else

/* FIXME: Not Empty - gotta be a better way */

void
notempty (void)
{
}

#endif /* _SEMAPHORE_ */
