/*
 * Copyright (c) 2005 by G4SRA
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/* 
 * Authors: G4SRA (cradford@bcs.org.uk)
 */

#ifndef _OM_SEMAPHORE_H
#define _OM_SEMAPHORE_H

#ifdef _OM_SEMAPHORE_

typedef struct {
  int lock_rw;
  int lock_r;
} rw_semaphore_t;

extern rw_semaphore_t cluster_semaphore;

void
  init_rwsem (rw_semaphore_t * sem);

void
  down_write (rw_semaphore_t * sem);

void
  up_write (rw_semaphore_t * sem);

void
  down_read (rw_semaphore_t * sem);

void
  up_read (rw_semaphore_t * sem);

#else

#define rw_semaphore_t
#define init_rwsem(x)
#define down_write(x)
#define up_write(x)
#define down_read(x)
#define up_read(x)

#endif /* _SEMAPHORE_ */

#endif
