/*
 * Copyright (c) 2002 by Louis Zechtzer
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/* 
 * Authors: Louis Zechtzer (lou@clarity.net)
 * Authors: G4SRA (cradford@bcs.org.uk) 
 */

#ifndef _OM_SYS_H
#define _OM_SYS_H

/* finest granularity in seconds before we do anything */
#define SYS_POLL_FREQ   (11)
#define SYS_NODE_LIFE	(29)

#define SYS_FLAGS_DAEMON		( 1 << 0 )
#define SYS_FLAGS_CONTROLLER		( 1 << 1 )
#define SYS_FLAGS_DRONE 		( 1 << 2 )
#define SYS_FLAGS_GRID	 		( 1 << 3 )
#define SYS_FLAGS_POWER	 		( 1 << 4 )

#define SYS_GOT_SIGINT		( 1 << 0 )	/* Ignoring sigint when a daemon */
#define SYS_GOT_SIGTERM		( 1 << 1 )
#define SYS_GOT_SIGHUP		( 1 << 2 )	/* Dump information/toggle debug level */
#define SYS_GOT_SIGUSR1		( 1 << 3 )
#define SYS_GOT_SIGUSR2		( 1 << 4 )
#define SYS_GOT_SIGALRM		( 1 << 5 )
#define SYS_GOT_SIGCHLD		( 1 << 6 )
#define SYS_GOT_SIGTSTP		( 1 << 7 )
#define SYS_GOT_SIGCONT		( 1 << 8 )
#define SYS_GOT_SIGUNHANDLED	( 1 << 15 )


void omSysInitialize (void);
void omSysPollInterval (int sec);
void omSleep (int period);

extern double sys_qfactor;
extern int sys_sighandled;
extern int sys_flags;

#endif /* __OM_SYS_H */
