/*
 * Copyright (c) 2005 by Nathan Wiegand
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General Public
 * License, as published by the Free Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED IN ITS "AS IS" CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/* 
 * Authors: Nathan Wiegand (nathanwiegand@gmail.com)
 * Authors: G4SRA (cradford@bcs.org.uk) 
 */


#ifndef _OM_TCP_H
#define _OM_TCP_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>

#include <stdarg.h>

/* default tcp port to use */
#define MOSIX_TCP_PORT 3490

/* the maximum  pending connections queue length */
#define BACKLOG 10


/* max number of bytes in a message we can send at once */
#define MAX_MESSAGE_SIZE 256

/* max number of bytes we can get at once */
#define MAXDATASIZE 100

int omd_tcp_server_init (uint32_t * addr, int *sfd);
int omd_tcp_server_accept (int sockfd);

int omd_tcp_server (void);

int tcp_sendf (int *sd, const char *fmt, ...);
int tcp_bounce (char *ip, char *msg, int sd, char *fmt);

int tcp_send_selff (const char *fmt, ...);
int tcp_send_self (char *buf);

char *tcp_exchange_thingy (char *ip, const char *fmt, ...);
char *tcp_exchange_msg (char *ip, char *msg_snd);

int tcp_go_between (char *ip, char *req, char *beq);
int tcp_go_between2 (uint32_t s_addr, char *req, char *beq);

int tcp_chat_start (uint32_t addr);
int tcp_send (int *sd, char *buf);
char *tcp_recv (int *sd);

extern unsigned short mosix_tcp_port_nbo;

#endif
